//+------------------------------------------------------------------+
//|                                                  BB Macd nrp.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  DimGray
#property indicator_color2  DimGray
#property indicator_color3  Lime
#property indicator_color4  Red

//
//
//
//
//

extern int    FastLen         = 12;
extern int    SlowLen         = 26;
extern int    Length          =  9;
extern double StDv            = 1.0;

//
//
//
//
//

double buffer1[];
double buffer2[];
double bbMacd[];
double buffer4[];
double buffer5[];


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0, buffer1);
   SetIndexBuffer(1, buffer2);
   SetIndexBuffer(2, bbMacd);
   SetIndexBuffer(3, buffer4);
   SetIndexBuffer(4, buffer5);
      SetIndexStyle(2, DRAW_ARROW); SetIndexArrow(2, 159);
      SetIndexStyle(3, DRAW_ARROW); SetIndexArrow(3, 159);
   SetIndexEmptyValue(2,0.00);

   //
   //
   //
   //
   //
     
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+1);
   IndicatorShortName("BB Macd (" + FastLen + "," + SlowLen + "," + Length+")");
      SetIndexLabel(0, "Upperband");
      SetIndexLabel(1, "Lowerband");  
      SetIndexLabel(2, "BB Macd");
      SetIndexLabel(3, "BB Macd");
   return(0);
}

int deinit()
{
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   int counted_bars = IndicatorCounted();
   int limit,i;


   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
       limit = Bars - counted_bars;


   //
   //
   //
   //
   //
   
   double alpha = 2.0 / (Length + 1.0);
   for(i = limit; i >= 0 ; i--)
   {
         bbMacd[i]  = iMA(NULL,0,FastLen,0,MODE_EMA,PRICE_CLOSE,i) - iMA(NULL,0,SlowLen,0,MODE_EMA,PRICE_CLOSE,i);
         buffer5[i] = buffer5[i+1] + alpha*(bbMacd[i]-buffer5[i+1]);
               double sDev = iDeviation(bbMacd, buffer5[i], Length, i);
         buffer1[i] = buffer5[i] + (StDv * sDev);
         buffer2[i] = buffer5[i] - (StDv * sDev);
         buffer4[i] = EMPTY_VALUE;
               
         //
         //
         //
         //
         //
               
         if (bbMacd[i]<bbMacd[i+1]) buffer4[i] = bbMacd[i];
   }

   //
   //
   //
   //
   //
   
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double iDeviation(double& array[],double dMA, int period,int shift)
{
   double dSum = 0.00;
   int    i;

   for(i=0; i<period; i++) dSum += (array[shift+i]-dMA)*(array[shift+i]-dMA);
   
   return(MathSqrt(dSum/period));
}